//+------------------------------------------------------------------+
//|                                                        S-RoC.mq4 |
//|                                    Copyright (C) 2009 DragoTrade |
//|                        Licensed under GNU General Public License |
//+------------------------------------------------------------------+
#property copyright "DragoTrade" 

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Yellow
//---- input parameters
extern int 
      MA_Period      = 13,
      ROC_Period     = 21,
      MA_Method      = 1,  // ????? ??????????: 0 - MODE_SMA, 1 - MODE_EMA, 2 - MODE_SMMA, 3 - MODE_LWMA
      Shift          = 0,  // ?????
      Price          = 0;  // ????: 0 - PRICE_CLOSE, 1 - PRICE_OPEN, 2 - PRICE_HIGH, 3 - PRICE_LOW,
                           //       4 - PRICE_MEDIAN, 5 - PRICE_TYPICAL, 6 - PRICE_WEIGHTED
//---- buffers

double b[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,b);
   IndicatorShortName("S-RoC("+MA_Period+", "+ROC_Period+")");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i=Bars-(ROC_Period+MA_Period)-1;
   double t,curr,prev;
   while(i>=0)
   {
      curr=iMA(NULL,0,MA_Period,0,MA_Method,Price,i);
      prev=iMA(NULL,0,MA_Period,0,MA_Method,Price,i+ROC_Period);

      if(prev!=0)
      {
         t=(curr-prev)/prev;
      }
      b[i]=t;
      i--;
   }
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+